/**
 *******************************************************************************
 * @file    main.c
 *
 * @brief   Main program body.
 *
 * @author  DPM
 *
 * @version V1.0.0
 *
 * @date    2024-5-6
 *
 *******************************************************************************/

/*
    Copyright (c) 2024, DP Microelectronics Inc.

    Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:

    1. Redistributions of source code must retain the above copyright notice, this
       list of conditions and the following disclaimer.
    2. Redistributions in binary form must reproduce the above copyright notice,
       this list of conditions and the following disclaimer in the documentation
       and/or other materials provided with the distribution.
    3. Neither the name of the copyright holder nor the names of its contributors
       may be used to endorse or promote products derived from this software without
       specific prior written permission.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY
OF SUCH DAMAGE.
*/

/* Files include */
#include "main.h"
#include "dpm32m0xx.h"
#include "dpm32m0xx_eval.h"
#include "systick.h"
#include <stdio.h>

/**
  * @addtogroup DPM32M08X_LibSamples
  * @{
  */

/**
  * @addtogroup UART
  * @{
  */

/**
  * @addtogroup UART_Block
  * @{
  */

/* Private typedef --------------------------------------------------------------*/

/* Private define ---------------------------------------------------------------*/

/* Private macro ----------------------------------------------------------------*/

/* Private variables ------------------------------------------------------------*/
uint8_t tx_buf[] = "Hello Depp Microelectronics Development Board\n";
uint8_t rx_buf[16] = {0};

/* Private functions ------------------------------------------------------------*/

/**
  * @brief  The program entry function.
  * @retval int
  */
int main(void)
{
  uint32_t cnt = 0;
  /* Configure the system clock */
  SystemClockInit();
  /* Configure the system tick */
  SystickInit();

  /* LED Init */
  EVAL_LedInit(LED1);

  /********************* Operation  *********************/
  /* UART0 Init */
  EVAL_ComInit();

  /* Send data */
  while(tx_buf[cnt] != '\0')
  {
    if(UART_GetIntFlagStatus(EVAL_COM0, UART_INT_FLAG_TXE) == SET)
    {
      UART_SendData(EVAL_COM0, tx_buf[cnt++]);
    }
  }

  printf("\n********************* Please reply to any content, ending with '#'  *********************\n");
  cnt = 0;

  /* Receive data */
  while(cnt < 16)
  {
    if(UART_GetIntFlagStatus(EVAL_COM0, UART_INT_FLAG_RXNE) == SET)
    {
      /* Custom concluding remarks */
      if(UART_ReceiveData(EVAL_COM0) == '#')
      {
        break;
      }

      rx_buf[cnt++] = UART_ReceiveData(EVAL_COM0);
    }
  }

  /* print receive data */
  printf("\n********************* Receive  *********************\n");

  for(uint16_t i = 0; i < cnt; i++)
  {
    printf("%c ", rx_buf[i]);
  }

  uint32_t ledTime = 0;

  /* Infinite loop */
  while(1)
  {
    /* Runing led toggle */
    if(ledTime < GetTick())
    {
      ledTime = GetTick() + 1000;
      EVAL_LedToggle(LED1);
    }
  }
}

/**
  * @brief  This function is used to fputc.
  * @param  None
  * @retval None
  */
int fputc(int ch, FILE *f)
{
  while(UART_GetIntFlagStatus(EVAL_COM0, UART_INT_FLAG_TXE) == RESET);

  UART_SendData(EVAL_COM0, ch) ;
  return ch;
}


/**
  * @}
  */

/**
  * @}
  */

/**
  * @}
  */

/************************ (C) COPYRIGHT DP *****END OF FILE ***************************/
